# -*- coding: iso-8859-1 -*-
"""
    sendkey - Send key using MoinMessage

    @copyright: 2013, 2014 by Paul Boddie <paul@boddie.org.uk>
    @license: GNU GPL (v2 or later), see COPYING.txt for details.
"""

from MoinMessage import Message, GPG, sendMessage
from email.mime.application import MIMEApplication
from email.mime.text import MIMEText
import sys

def readkey(filename):
    f = open(filename, "rb")
    try:
        return MIMEApplication(f.read(), "pgp-keys")
    finally:
        f.close()

if __name__ == "__main__":
    try:
        recipient = sys.argv[1]
        url = sys.argv[2]
        filename = sys.argv[3]
        secret = sys.argv[4]
    except IndexError:
        secret = None

    if not secret:
        print >>sys.stderr, """\
Need a recipient key identifier, the destination URL, a key filename, and a
secret as arguments to this program.
"""
        sys.exit(1)

    # Bundle the key and secret into a message.

    message = Message()

    part = readkey(filename)
    message.add_update(part)

    part = MIMEText(secret)
    message.add_update(part)

    # Get the e-mail message itself.

    email_message = message.get_payload("x-moinmessage-keys")

    # Sign (for authorship), encrypt (for privacy), sign (for authentication),
    # and send the message.

    gpg = GPG()
    encrypted_message = gpg.encryptMessage(email_message, recipient)

    resp = sendMessage(encrypted_message, url)

    print resp

# vim: tabstop=4 expandtab shiftwidth=4
